#ifndef SU2MIXED_H
#define SU2MIXED_H

#include "SU2.h"
#include "init.h"
#include "lattice.h"
#include "random.h"
#include "SU2Wilson.h"

class SU2Mixed : public SU2Wilson {
public:

	SU2Mixed(Lattice &MyLat);
	void Metropolis(int LinCoord,int mu);
	double Action(SU2& Umu,int LinCoord,int mu);
	double Action0(SU2& Umu,int LinCoord,int mu);
	void Evolve(int NmOR=0);//NmOR not implemented for this action
	//allow for a time slice update
	void EvolveSlice(int tin, int tfin);
	void EvolveMetro();
	void Equilibrium(int );
	SU2 RMatrix();
	~SU2Mixed();
private:
	ofstream OutAcceptFile;
};
#endif

