#ifndef SU2WILSON_H
#define SU2WILSON_H
#define CREUTZ
#include "SU2.h"
#include "init.h"
#include "lattice.h"
#include "random.h"

// define SU(2) algorithm: Creutz or KennedyPendleton (default)
//#define CREUTZ

class SU2Wilson{
public:

	SU2Wilson(Lattice &MyLat);
	void Evolve(int nMOR=0);//NmOR - overrrelaxation sweeps
	virtual void EvolveSlice(int tin, int tfin);
	void Equilibrium(int );
	SU2 HBtry(int LinCoord,int mu);
	SU2 ORtry(int LinCoord, int mu);
#ifdef CREUTZ
	void Creutz(const double weight, double &a0);
#else
	void KennedyPendleton(const double weight, double &a0);
#endif
	virtual ~SU2Wilson();
protected:
	Lattice *Lat;
};
#endif
