#ifndef MEAS_H
#define MEAS_H

#include "init.h"
#include "SU2.h"
#include "lattice.h"
#include "SU2Wilson.h"
#include "SU2xSU2.h"

class Meas{
public:

	Meas(Lattice &MyLat);
/*	template<int rep2>
	inline double Plaq();*/
	vector<double> PlaqAll(int MaxRep2);
	double Plaq(int rep2);
	vector<double> WloopAll(int Length=2);
	double Wloop(int Length=2);//"Length x Length"  Wilson loop
	double Ploop(int tin=0, int tfi=-1);
	const SU2 PloopXYZ(LatVec crd, int tin=0,int tfi=-1);
	void PloopCor(int rMax, vector <double> * Ploop);
	void PWloopCorLW(const int rMax,SU2Wilson & MyModel, vector <double> * Ploop, vector <double> *Wloop=0);
	//template 
	~Meas();
private:
	Lattice *Lat;
};
//-------------------------------
/*template<int rep2>
double Meas::Plaq()
{
	LatVec ShiftVec;
	double plq=0;
	int LinCoord_mu;
	for (int LinCoord =0; LinCoord<Lat->Vol; LinCoord++) {
		for (int mu=1;mu<Nd;mu++) {
			ShiftVec[0]=0;ShiftVec[1]=0;ShiftVec[2]=0;ShiftVec[3]=0;ShiftVec[mu]=1;
			LinCoord_mu=Lat->CoordShift(LinCoord,  ShiftVec);
			for (int nu=0;nu<mu;nu++) {
				ShiftVec[0]=0;ShiftVec[1]=0;ShiftVec[2]=0;ShiftVec[3]=0;ShiftVec[nu]=1;
				plq+=((*Lat->Umu(LinCoord,  mu))*(*Lat->Umu(LinCoord_mu,  nu))*
					(*Lat->Umu(Lat->CoordShift(LinCoord, ShiftVec), mu)).dagger()*
					(*Lat->Umu(LinCoord,  nu)).dagger()).Trr(rep2);
			}
		}
	}
	return (2*plq/(Lat->Vol*Nd*(Nd-1))); //1/(V*Nd*(Nd-1)/2)
}*/

#endif
