#ifndef RANDOM_H
#define RANDOM_H

#include <iostream>
#include <cstdlib>

//Random Number Generator Class (Marsaglia or Built-in).
//velytsky, 2005
//--- type of random number generator to use ---
#define MARSAGLIA
//---

#ifdef MARSAGLIA

class Random {
	public:
		Random(int iseed1=1,int iseed2=0);
		inline double get(){
			double uni;
			uni=mar_u[mar_i-1]-mar_u[mar_j-1];
			if(uni<0.0) uni+=1.0;
			mar_u[mar_i-1]=uni;
			mar_i--;
			if(mar_i==0) mar_i=97;
			mar_j--;
			if(mar_j==0) mar_j=97;
			mar_c-=mar_cd;
			if(mar_c<0.0) mar_c+=mar_cm;
			uni-=mar_c;
			if(uni<0.0) uni+=1.0;
			return uni;	
		};
	private:
		void rmaset(int seed1, int seed2);
		double mar_u[97];
		double mar_c, mar_cd, mar_cm;
		int mar_i,mar_j;
};

#else

class Random {
	public:
		Random(){}
		Random(int iseed1,int iseed2) {
			srand(iseed1);
			std::cerr<<"WARNING: stdlib RNG takes only one initial seed!"<<std::endl;
		}
		Random(int iseed1) {
			srand(iseed1);
		}
		inline double get() {
			return rand()/(RAND_MAX+1.0);
		}
};
#endif

#endif
